---
title: "FreeBSD 7.3-RELEASE Release Notes"
sidenav: download
---

++++


<h3 class="CORPAUTHOR">The FreeBSD Project</h3>

<p class="COPYRIGHT">Copyright &copy; 2010 The FreeBSD Documentation Project</p>

<p class="PUBDATE">$FreeBSD: releng/7.3/release/doc/en_US.ISO8859-1/relnotes/article.sgml
205387 2010-03-20 16:39:28Z hrs $<br />
</p>

<div class="LEGALNOTICE"><a id="TRADEMARKS" name="TRADEMARKS"></a>
<p>FreeBSD is a registered trademark of the FreeBSD Foundation.</p>

<p>IBM, AIX, EtherJet, Netfinity, OS/2, PowerPC, PS/2, S/390, and ThinkPad are trademarks
of International Business Machines Corporation in the United States, other countries, or
both.</p>

<p>IEEE, POSIX, and 802 are registered trademarks of Institute of Electrical and
Electronics Engineers, Inc. in the United States.</p>

<p>Intel, Celeron, EtherExpress, i386, i486, Itanium, Pentium, and Xeon are trademarks or
registered trademarks of Intel Corporation or its subsidiaries in the United States and
other countries.</p>

<p>Sparc, Sparc64, SPARCEngine, and UltraSPARC are trademarks of SPARC International, Inc
in the United States and other countries. Products bearing SPARC trademarks are based
upon architecture developed by Sun Microsystems, Inc.</p>

<p>Many of the designations used by manufacturers and sellers to distinguish their
products are claimed as trademarks. Where those designations appear in this document, and
the FreeBSD Project was aware of the trademark claim, the designations have been followed
by the &#8220;&trade;&#8221; or the &#8220;&reg;&#8221; symbol.</p>
</div>

<div>
<div class="ABSTRACT"><a id="AEN18" name="AEN18"></a>
<p>The release notes for FreeBSD 7.3-RELEASE contain a summary of the changes made to the
FreeBSD base system on the 7.3-STABLE development line. This document lists applicable
security advisories that were issued since the last release, as well as significant
changes to the FreeBSD kernel and userland. Some brief remarks on upgrading are also
presented.</p>
</div>
</div>

<hr />
</div>

<div class="TOC">
<dl>
<dt><b>Table of Contents</b></dt>

<dt>1 <a href="#INTRO">Introduction</a></dt>

<dt>2 <a href="#NEW">What's New</a></dt>

<dd>
<dl>
<dt>2.1 <a href="#SECURITY">Security Advisories</a></dt>

<dt>2.2 <a href="#KERNEL">Kernel Changes</a></dt>

<dd>
<dl>
<dt>2.2.1 <a href="#BOOT">Boot Loader Changes</a></dt>

<dt>2.2.2 <a href="#PROC">Hardware Support</a></dt>

<dt>2.2.3 <a href="#NET-PROTO">Network Protocols</a></dt>

<dt>2.2.4 <a href="#DISKS">Disks and Storage</a></dt>

<dt>2.2.5 <a href="#FS">File Systems</a></dt>
</dl>
</dd>

<dt>2.3 <a href="#USERLAND">Userland Changes</a></dt>

<dd>
<dl>
<dt>2.3.1 <a href="#RC-SCRIPTS"><tt class="FILENAME">/etc/rc.d</tt> Scripts</a></dt>
</dl>
</dd>

<dt>2.4 <a href="#CONTRIB">Contributed Software</a></dt>

<dt>2.5 <a href="#PORTS">Ports/Packages Collection Infrastructure</a></dt>

<dt>2.6 <a href="#RELENG">Release Engineering and Integration</a></dt>
</dl>
</dd>

<dt>3 <a href="#UPGRADE">Upgrading from previous releases of FreeBSD</a></dt>
</dl>
</div>

<div class="SECT1">
<h2 class="SECT1"><a id="INTRO" name="INTRO">1 Introduction</a></h2>

<p>This document contains the release notes for FreeBSD 7.3-RELEASE. It describes
recently added, changed, or deleted features of FreeBSD. It also provides some notes on
upgrading from previous versions of FreeBSD.</p>

<p>This distribution of FreeBSD 7.3-RELEASE is a release distribution. It can be found at
<a href="ftp://ftp.FreeBSD.org/" target="_top">ftp://ftp.FreeBSD.org/</a> or any of its
mirrors. More information on obtaining this (or other) release distributions of FreeBSD
can be found in the <a href="../../../../doc/en_US.ISO8859-1/books/handbook/mirrors.html"
target="_top">&#8220;Obtaining FreeBSD&#8221; appendix</a> to the <a
href="../../../../doc/en_US.ISO8859-1/books/handbook/" target="_top">FreeBSD
Handbook</a>.</p>

<p>All users are encouraged to consult the release errata before installing FreeBSD. The
errata document is updated with &#8220;late-breaking&#8221; information discovered late
in the release cycle or after the release. Typically, it contains information on known
bugs, security advisories, and corrections to documentation. An up-to-date copy of the
errata for FreeBSD 7.3-RELEASE can be found on <a
href="http://www.FreeBSD.org/releases/7.3R/errata.html"
target="_top">http://www.FreeBSD.org/releases/7.3R/errata.html</a>.</p>
</div>

<div class="SECT1">
<hr />
<h2 class="SECT1"><a id="NEW" name="NEW">2 What's New</a></h2>

<p>This section describes the most user-visible new or changed features in FreeBSD since
7.2-RELEASE.</p>

<p>Typical release note items document recent security advisories issued after
7.2-RELEASE, new drivers or hardware support, new commands or options, major bug fixes,
or contributed software upgrades. They may also list changes to major ports/packages or
release engineering practices. Clearly the release notes cannot list every single change
made to FreeBSD between releases; this document focuses primarily on security advisories,
user-visible changes, and major architectural improvements.</p>

<div class="SECT2">
<hr />
<h3 class="SECT2"><a id="SECURITY" name="SECURITY">2.1 Security Advisories</a></h3>

<p>Problems described in the following security advisories have been fixed. For more
information, consult the individual advisories available from <a
href="http://security.FreeBSD.org/" target="_top">http://security.FreeBSD.org/</a>.</p>

<div class="INFORMALTABLE"><a id="AEN39" name="AEN39"></a>
<table border="0" frame="void" class="CALSTABLE">
<col width="1*" />
<col width="1*" />
<col width="3*" />
<thead>
<tr>
<th>Advisory</th>
<th>Date</th>
<th>Topic</th>
</tr>
</thead>

<tbody>
<tr>
<td><a href="http://security.freebsd.org/advisories/FreeBSD-SA-09:09.pipe.asc"
target="_top">SA-09:09.pipe</a></td>
<td>10&nbsp;June&nbsp;2009</td>
<td>
<p>Local information disclosure via direct pipe writes</p>
</td>
</tr>

<tr>
<td><a href="http://security.freebsd.org/advisories/FreeBSD-SA-09:10.ipv6.asc"
target="_top">SA-09:10.ipv6</a></td>
<td>10&nbsp;June&nbsp;2009</td>
<td>
<p>Missing permission check on SIOCSIFINFO_IN6 ioctl</p>
</td>
</tr>

<tr>
<td><a href="http://security.freebsd.org/advisories/FreeBSD-SA-09:11.ntpd.asc"
target="_top">SA-09:11.ntpd</a></td>
<td>10&nbsp;June&nbsp;2009</td>
<td>
<p>ntpd stack-based buffer-overflow vulnerability</p>
</td>
</tr>

<tr>
<td><a href="http://security.freebsd.org/advisories/FreeBSD-SA-09:12.bind.asc"
target="_top">SA-09:12.bind</a></td>
<td>29&nbsp;July&nbsp;2009</td>
<td>
<p>BIND <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=named&sektion=8&manpath=FreeBSD+7.3-stable">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">named</span>(8)</span></a> dynamic
update message remote DoS</p>
</td>
</tr>

<tr>
<td><a href="http://security.freebsd.org/advisories/FreeBSD-SA-09:14.devfs.asc"
target="_top">SA-09:14.devfs</a></td>
<td>2&nbsp;Oct&nbsp;2009</td>
<td>
<p>Devfs / VFS NULL pointer race condition</p>
</td>
</tr>

<tr>
<td><a href="http://security.freebsd.org/advisories/FreeBSD-SA-09:15.ssl.asc"
target="_top">SA-09:15.ssl</a></td>
<td>3&nbsp;Dec&nbsp;2009</td>
<td>
<p>SSL protocol flaw</p>
</td>
</tr>

<tr>
<td><a href="http://security.freebsd.org/advisories/FreeBSD-SA-09:16.rtld.asc"
target="_top">SA-09:16.rtld</a></td>
<td>3&nbsp;Dec&nbsp;2009</td>
<td>
<p>Improper environment sanitization in <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=rtld&sektion=1&manpath=FreeBSD+7.3-stable">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">rtld</span>(1)</span></a></p>
</td>
</tr>

<tr>
<td><a href="http://security.freebsd.org/advisories/FreeBSD-SA-09:17.freebsd-update.asc"
target="_top">SA-09:17.freebsd-update</a></td>
<td>3&nbsp;Dec&nbsp;2009</td>
<td>
<p>Inappropriate directory permissions in <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=freebsd-update&sektion=8&manpath=FreeBSD+7.3-stable">
<span class="CITEREFENTRY"><span
class="REFENTRYTITLE">freebsd-update</span>(8)</span></a></p>
</td>
</tr>

<tr>
<td><a href="http://security.freebsd.org/advisories/FreeBSD-SA-10:01.bind.asc"
target="_top">SA-10:01.bind</a></td>
<td>6&nbsp;Jan&nbsp;2010</td>
<td>
<p>BIND <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=named&sektion=8&manpath=FreeBSD+7.3-stable">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">named</span>(8)</span></a> cache
poisoning with DNSSEC validation</p>
</td>
</tr>

<tr>
<td><a href="http://security.freebsd.org/advisories/FreeBSD-SA-10:02.ntpd.asc"
target="_top">SA-10:02.ntpd</a></td>
<td>6&nbsp;Jan&nbsp;2010</td>
<td>
<p>ntpd mode 7 denial of service</p>
</td>
</tr>

<tr>
<td><a href="http://security.freebsd.org/advisories/FreeBSD-SA-10:03.zfs.asc"
target="_top">SA-10:03.zfs</a></td>
<td>6&nbsp;Jan&nbsp;2010</td>
<td>
<p>ZFS ZIL playback with insecure permissions</p>
</td>
</tr>
</tbody>
</table>
</div>
</div>

<div class="SECT2">
<hr />
<h3 class="SECT2"><a id="KERNEL" name="KERNEL">2.2 Kernel Changes</a></h3>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=closefrom&sektion=2&manpath=FreeBSD+7.3-stable">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">closefrom</span>(2)</span></a>
system call has been added. This closes any open file descriptors which are equal to or
larger than the specified value. Note that this does not fail with any errors and this is
not multi-thread safe.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ddb&sektion=8&manpath=FreeBSD+7.3-stable"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">ddb</span>(8)</span></a> subcommands
for <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=geom&sektion=8&manpath=FreeBSD+7.3-stable">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">geom</span>(8)</span></a> now
supports pagination.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=futimes&sektion=2&manpath=FreeBSD+7.3-stable">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">futimes</span>(2)</span></a>, <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=lutimes&sektion=2&manpath=FreeBSD+7.3-stable">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">lutimes</span>(2)</span></a>, and
<a
href="http://www.FreeBSD.org/cgi/man.cgi?query=utimes&sektion=2&manpath=FreeBSD+7.3-stable">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">utimes</span>(2)</span></a> system
call now support a sysctl variable <code
class="VARNAME">vfs.timestamp_precision</code>.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=jail&sektion=8&manpath=FreeBSD+7.3-stable">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">jail</span>(8)</span></a>
subsystem now supports <code class="VARNAME">security.jail.ip4_saddrsel</code> and <code
class="VARNAME">security.jail.ip6_saddrsel</code> sysctl variables to control whether to
use source address selection or the primary jail address for unbound outgoing
connections. The default is that the source address selection is enabled. Also, the jail
parameter <code class="VARNAME">ip4.saddrsel</code> and <code
class="VARNAME">ip6.saddrsel</code> are boolean option to enable the source address
selection for IPv4 and IPv6, respectively. If the boolean parameters <code
class="VARNAME">ip4.nosaddrsel</code> and <code class="VARNAME">ip6.nosaddrsel</code> are
set, the child jails do not inherit the address selection options of the parent.</p>

<p>[amd64] The <code class="VARNAME">kmem_map</code> KVA space has been increased to
512GB.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=lindev&sektion=4&manpath=FreeBSD+7.3-stable">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">lindev</span>(4)</span></a> driver
has been added. This is for Linux-specific pseudo devices and currently used only for <tt
class="FILENAME">/dev/full</tt>.</p>

<p>FreeBSD Linux emulation layer now supports <code class="VARNAME">SO_PEERCRED</code>
socket option, <code class="VARNAME">MSG_CMSG_CLOEXEC</code> for <code
class="FUNCTION">recvmsg()</code>, and robust futex. The futex has been reimplemented by
using <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sx&sektion=9&manpath=FreeBSD+7.3-stable"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">sx</span>(9)</span></a> lock. Initial
support of <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ktr&sektion=4&manpath=FreeBSD+7.3-stable"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">ktr</span>(4)</span></a> tracing has
also been added.</p>

<p>A lock handling error has been fixed in interaction between <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=malloc&sektion=3&manpath=FreeBSD+7.3-stable">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">malloc</span>(3)</span></a>
implementation and threading library. When a multi-threaded process calls the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=fork&sektion=2&manpath=FreeBSD+7.3-stable">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">fork</span>(2)</span></a> system
call in a thread and the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=malloc&sektion=3&manpath=FreeBSD+7.3-stable">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">malloc</span>(3)</span></a>
function in another thread, it caused a deadlock in the child process.</p>

<p>PECOFF image activator support has been removed.</p>

<p>FreeBSD now supports POSIX semaphores (<code
class="VARNAME">P1003_1B_SEMAPHORES</code> kernel option) by default.</p>

<p>A deadlock in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sched_ule&sektion=4&manpath=FreeBSD+7.3-stable">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">sched_ule</span>(4)</span></a>
scheduler has been fixed. For more details, see <a
href="http://security.freebsd.org/advisories/FreeBSD-EN-10:02.sched_ule.asc"
target="_top">EN-10:02.sched_ule</a>.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sglist&sektion=9&manpath=FreeBSD+7.3-stable">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">sglist</span>(9)</span></a> API to
manage scatter/gather lists of physical addresses has been added.</p>

<p>FreeBSD ABI of some of the structures used by the System V IPC API has been changed
internally, and it now supports shared memory segments for System V IPC which is larger
than 2GB on 64-bit platforms. For new kernel modules, the <code
class="FUNCTION">kern_msgctl()</code>, <code class="FUNCTION">kern_semctl()</code>, and
<code class="FUNCTION">kern_shmctl()</code> functions will be transparently renamed to
the new <code class="FUNCTION">kern_new_*()</code> functions by using ABI shims. The old
functions remain as the old names to provide backward compatibility for older kernel
modules.</p>

<p>A new sysctl variable <code class="VARNAME">security.bsd.map_at_zero</code> has been
added and set to <tt class="LITERAL">1</tt> (allow) by default. This controls whether
FreeBSD allows to map an object at the address <tt class="LITERAL">0</tt>, which is part
of the user-controlled portion of the virtual address space. Disabling this has some
effect on preventing an attack which injects malicious code into that location and
triggers a NULL pointer dereference in the kernel.</p>

<div class="SECT3">
<hr />
<h4 class="SECT3"><a id="BOOT" name="BOOT">2.2.1 Boot Loader Changes</a></h4>

<p>A new boot loader <tt class="LITERAL">gptzfsboot</tt>, which supports GPT and ZFS has
been added.</p>

<p>The boot loader <tt class="LITERAL">zfsboot</tt> now always uses 64-bit LBAs and
supports more than seven drives in the ZFS pools.</p>

<p>A bug in <tt class="LITERAL">zfsboot</tt> has been fixed. A <tt
class="FILENAME">/boot.config</tt> smaller than 512 bytes was ignored.</p>

<p><tt class="LITERAL">zfsloader</tt>, the final boot loader similar to <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=loader&sektion=8&manpath=FreeBSD+7.3-stable">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">loader</span>(8)</span></a> which
supports ZFS has been added.</p>

<p>A bug in the boot loader has been fixed. It failed to recognize GPT correctly when the
system supports both of MBR and GPT and they are synchronized with each other.</p>

<p>[pc98] The <b class="APPLICATION">boot2</b> program has been reimplemented based on
the latest version for i386.</p>
</div>

<div class="SECT3">
<hr />
<h4 class="SECT3"><a id="PROC" name="PROC">2.2.2 Hardware Support</a></h4>

<p>The <b class="APPLICATION">amdsbwd(4)</b> driver for AMD SB600/SB7xx watchdog timer
has been added.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=cpuctl&sektion=4&manpath=FreeBSD+7.3-stable">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">cpuctl</span>(4)</span></a> driver
now supports atomically setting/clearing individual bits of a MSR register. Two new ioctl
calls <code class="VARNAME">CPUCTL_MSRSBIT</code> and <code
class="VARNAME">CPUCTL_MSRCBIT</code> treat the data field of struct in the argument
passed as a mask and set/clear bits of the MSR register according to the mask value. The
<a
href="http://www.FreeBSD.org/cgi/man.cgi?query=cpucontrol&sektion=8&manpath=FreeBSD+7.3-stable">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">cpucontrol</span>(8)</span></a>
utility also supports this feature. For more details, see Userland Changes section.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=cpufreq&sektion=4&manpath=FreeBSD+7.3-stable">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">cpufreq</span>(4)</span></a>
driver now supports Phenom (Family 10h).</p>

<p>[amd64, i386] CPU cache flushing has been optimized when changing caching attributes
of pages by doing nothing for CPUs that support self-snooping and using <tt
class="LITERAL">CLFLUSH</tt> instead of a full cache invalidate when possible. FreeBSD
does not use <tt class="LITERAL">CLFLUSH</tt> on Intel CPUs due to problems with flushing
the local APIC range by default. This can be controlled via the <code
class="VARNAME">hw.clflush_disable</code> loader tunable. A setting of <tt
class="LITERAL">1</tt> disables the use of <tt class="LITERAL">CLFLUSH</tt>. A setting of
<tt class="LITERAL">0</tt> allows <tt class="LITERAL">CLFLUSH</tt> to be used for Intel
CPUs when <tt class="LITERAL">CPUID_SS</tt> is not present. This fixes a kernel panic
occurred on Xen which disables self-snooping.</p>

<p>[sparc64] The epic(4) driver for the front panel LEDs in Sun Fire V215/V245 has been
added.</p>

<p>[sparc64] The fire(4) driver for &#8220;Fire&#8221; JBus to PCIe bridges found in at
least the Sun Fire V215/V245 and Sun Ultra 25/45 machines has been added.</p>

<p>[amd64, i386] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=hwpmc&sektion=4&manpath=FreeBSD+7.3-stable">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">hwpmc</span>(4)</span></a> driver
for Hardware Performance Monitoring Counter support has been added. This consists of the
kernel driver, <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=pmc&sektion=3&manpath=FreeBSD+7.3-stable"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">pmc</span>(3)</span></a> interface
library, and userland utilities <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=pmcannotate&sektion=8&manpath=FreeBSD+7.3-stable">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">pmcannotate</span>(8)</span></a>,
<a
href="http://www.FreeBSD.org/cgi/man.cgi?query=pmccontrol&sektion=8&manpath=FreeBSD+7.3-stable">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">pmccontrol</span>(8)</span></a>,
and <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=pmcstat&sektion=8&manpath=FreeBSD+7.3-stable">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">pmcstat</span>(8)</span></a>, and
allows applications to use hardware performance counters to gather performance data about
specific processes or for the system as a whole.</p>

<p>Several bugs in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ipmi&sektion=4&manpath=FreeBSD+7.3-stable">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ipmi</span>(4)</span></a> driver
which prevents the watchdog timeout setting from working, have been fixed.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=k8temp&sektion=4&manpath=FreeBSD+7.3-stable">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">k8temp</span>(4)</span></a> driver
has been renamed with <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=amdtemp&sektion=4&manpath=FreeBSD+7.3-stable">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">amdtemp</span>(4)</span></a>. The
new driver supports AMD K10 and K11 as well as K8.</p>

<p>A loader tunable <code class="VARNAME">hw.mca.enabled</code> has been added. This can
be used to enable/disable the machine check code. Disabled by default.</p>

<p>A sysctl variable <code class="VARNAME">hw.pagesizes</code> has been added. This
reports all of the supported page sizes on the system.</p>

<p>PCI Express memory-mapped configuration space access, ACPI MCFG table support, and BAR
(Base Address Register) handling in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=pci&sektion=4&manpath=FreeBSD+7.3-stable"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">pci</span>(4)</span></a> subsystem has
been improved. This is disabled by default and can be enabled by setting a loader tunable
<code class="VARNAME">hw.pci.mcfg</code> to <tt class="LITERAL">1</tt>. This value can be
queried via a sysctl variable of the same name.</p>

<p>[amd64, i386] FreeBSD now supports VIA Nano processor family.</p>

<div class="SECT4">
<hr />
<h5 class="SECT4"><a id="MM" name="MM">2.2.2.1 Multimedia Support</a></h5>

<p><b class="APPLICATION">DRM</b> now supports Radeon HD 4200 (RS880), 4770 (RV740), and
R6/7xx 3D, and Intel G41 chips.</p>

<p>The vgapci(4) driver for PCI VGA display devices which can attach devices as the
children now supports proxying of PCI MSI/MSI-X (Message Signaled Interrupt) requests and
bus interrupt requests for the child devices. This allows child devices to use MSI/MSI-X
interrupts.</p>
</div>

<div class="SECT4">
<hr />
<h5 class="SECT4"><a id="NET-IF" name="NET-IF">2.2.2.2 Network Interface Support</a></h5>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=alc&sektion=4&manpath=FreeBSD+7.3-stable"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">alc</span>(4)</span></a> driver for
Atheros AR8131/AR8132 PCIe Ethernet controller has been added.</p>

<p>A bug in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=bce&sektion=4&manpath=FreeBSD+7.3-stable"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">bce</span>(4)</span></a> driver has
been fixed. When adding a <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=bce&sektion=4&manpath=FreeBSD+7.3-stable"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">bce</span>(4)</span></a> interface on
the system as a <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=lagg&sektion=4&manpath=FreeBSD+7.3-stable">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">lagg</span>(4)</span></a> member
with the LACP aggregation protocol enabled network communication via the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=bce&sektion=4&manpath=FreeBSD+7.3-stable"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">bce</span>(4)</span></a> interface
stopped completely. Although the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=bce&sektion=4&manpath=FreeBSD+7.3-stable"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">bce</span>(4)</span></a> interface
worked if it was not a <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=lagg&sektion=4&manpath=FreeBSD+7.3-stable">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">lagg</span>(4)</span></a> member,
the incoming traffic statistics which can be found in <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=netstat&sektion=1&manpath=FreeBSD+7.3-stable">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">netstat</span>(1)</span></a>
output was incorrect because every packet was recognized as full-sized one.</p>

<p>Several bugs in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=bge&sektion=4&manpath=FreeBSD+7.3-stable"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">bge</span>(4)</span></a> driver have
been fixed. It caused a panic when a lot of traffic is being handled on the interface
while the system is shutting down, and had a DMA issue when buffer address crosses a
multiple of the 4GB boundaries.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=bge&sektion=4&manpath=FreeBSD+7.3-stable"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">bge</span>(4)</span></a> driver now
supports TSO (TCP segmentation offloading) for BCM5755 or newer chips.</p>

<p>[sparc64] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=cas&sektion=4&manpath=FreeBSD+7.3-stable"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">cas</span>(4)</span></a> driver has
been added to provide support for Sun Cassini/Cassini+ and National Semiconductor DP83065
Saturn Gigabit Ethernet devices.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=cxgb&sektion=4&manpath=FreeBSD+7.3-stable">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">cxgb</span>(4)</span></a> driver
has been upgraded to the latest version. The firmware version is 7.8.0.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=et&sektion=4&manpath=FreeBSD+7.3-stable"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">et</span>(4)</span></a> driver now
supports IPv4/TCP/UDP Tx checksum offloading.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=fxp&sektion=4&manpath=FreeBSD+7.3-stable"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">fxp</span>(4)</span></a> driver has
been improved. The multicast filter re-programming is now more robust. A bug which caused
incorrect IP packet length in the header when TSO (TCP segmentation offloading) is
enabled has been fixed. This fixes poor performance when TSO is enabled in the previous
releases.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=msk&sektion=4&manpath=FreeBSD+7.3-stable"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">msk</span>(4)</span></a> driver has
been improved for robust operation. Also, it now supports Yukon FE+ A0 including 88E8040,
88E8040T, 88E8042, 88E8048, 88E8057, and 88E8070.</p>

<p>Several bugs in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=mxge&sektion=4&manpath=FreeBSD+7.3-stable">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">mxge</span>(4)</span></a> driver
have been fixed and the firmware version is now 1.4.48b. It could lose the promiscuous
flag on resetting and cause a kernel panic on the hardware fault.</p>

<p>A bug in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=nfe&sektion=4&manpath=FreeBSD+7.3-stable"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">nfe</span>(4)</span></a> driver has
been fixed. It caused buffer allocation failure for jumbo frames.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=nge&sektion=4&manpath=FreeBSD+7.3-stable"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">nge</span>(4)</span></a> driver has
been improved and now works on all supported platforms. It now supports <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=altq&sektion=4&manpath=FreeBSD+7.3-stable">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">altq</span>(4)</span></a>,
hardware checksum offloading for <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=vlan&sektion=4&manpath=FreeBSD+7.3-stable">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">vlan</span>(4)</span></a> tagged
frames, WoL (Wake-on-Lan), jumbo frames, and PCI MWI (Memory Write and Invalidate)
commands. Hardware MAC statistics can be obtained via a new sysctl variable <code
class="VARNAME">dev.nge.<tt class="REPLACEABLE"><i>N</i></tt>.stats</code>. Another new
sysctl variable <code class="VARNAME">dev.nge.<tt
class="REPLACEABLE"><i>N</i></tt>.int_holdoff</code> has been added to control interrupt
moderation. The valid ranges are <tt class="LITERAL">1</tt> (100us) to <tt
class="LITERAL">255</tt>, and the actual delivery of interrupt would be delayed based on
this value. The default is <tt class="LITERAL">1</tt>. For more details, see <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=nge&sektion=4&manpath=FreeBSD+7.3-stable"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">nge</span>(4)</span></a> manual
page.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ste&sektion=4&manpath=FreeBSD+7.3-stable"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">ste</span>(4)</span></a> driver has
been improved and now works on all supported platforms. It now supports suspend/resume
and WoL (Wake-on-Lan). Hardware MAC statistics can be obtained via a new sysctl variable
<code class="VARNAME">dev.ste.<tt class="REPLACEABLE"><i>N</i></tt>.stats</code>. Another
new sysctl variables <code class="VARNAME">dev.ste.<tt
class="REPLACEABLE"><i>N</i></tt>.int_rx_mod</code> has been added to control RX
interrupt moderation time. The default value is <tt class="LITERAL">150</tt> (150us). For
more details, see <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ste&sektion=4&manpath=FreeBSD+7.3-stable"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">ste</span>(4)</span></a> manual
page.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=vge&sektion=4&manpath=FreeBSD+7.3-stable"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">vge</span>(4)</span></a> driver has
been improved. It now supports hardware checksum offloading for <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=vlan&sektion=4&manpath=FreeBSD+7.3-stable">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">vlan</span>(4)</span></a> tagged
frames and WoL (Wake-on-Lan). Hardware MAC statistics can be obtained via a new sysctl
variable <code class="VARNAME">dev.vge.<tt
class="REPLACEABLE"><i>N</i></tt>.stats</code>. Another new sysctl variables <code
class="VARNAME">dev.nge.<tt class="REPLACEABLE"><i>N</i></tt>.int_holdoff</code>, <code
class="VARNAME">dev.nge.<tt class="REPLACEABLE"><i>N</i></tt>.rx_coal_pkt</code>, and
<code class="VARNAME">dev.nge.<tt class="REPLACEABLE"><i>N</i></tt>.tx_coal_pkt</code>
has been added to control interrupt moderation. For more details, see <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=vge&sektion=4&manpath=FreeBSD+7.3-stable"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">vge</span>(4)</span></a> manual
page.</p>

<p>A bug in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=xl&sektion=4&manpath=FreeBSD+7.3-stable"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">xl</span>(4)</span></a> driver which
caused occasional watchdog timeouts has been fixed.</p>
</div>
</div>

<div class="SECT3">
<hr />
<h4 class="SECT3"><a id="NET-PROTO" name="NET-PROTO">2.2.3 Network Protocols</a></h4>

<p>A bug in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=gif&sektion=4&manpath=FreeBSD+7.3-stable"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">gif</span>(4)</span></a> that EtherIP
packets sent by combination of <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=if_bridge&sektion=4&manpath=FreeBSD+7.3-stable">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">if_bridge</span>(4)</span></a> and
<a
href="http://www.FreeBSD.org/cgi/man.cgi?query=gif&sektion=4&manpath=FreeBSD+7.3-stable"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">gif</span>(4)</span></a> have a
reversed version field has been fixed. If you need to communicate with older FreeBSD
releases via EtherIP, use new flags <tt class="LITERAL">accept_rev_ethip_ver</tt> and <tt
class="LITERAL">send_rev_ethip_ver</tt> to control handling the reversed version field.
These can be set by <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ifconfig&sektion=8&manpath=FreeBSD+7.3-stable">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ifconfig</span>(8)</span></a>
utility to <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=gif&sektion=4&manpath=FreeBSD+7.3-stable"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">gif</span>(4)</span></a> interfaces.
The EtherIP implementation found on FreeBSD 6.1, 6.2, 6.3, 7.0, 7.1, and 7.2 had an
interoperability issue because it sent the incorrect EtherIP packets and discarded the
correct ones. For more details, see <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=gif&sektion=4&manpath=FreeBSD+7.3-stable"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">gif</span>(4)</span></a> manual
page.</p>

<p>IPcomp protocol is now enabled by default. This can be controlled by a sysctl variable
<code class="VARNAME">net.inet.ipcomp.ipcomp_enable</code>.</p>

<p>A bug in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ng_iface&sektion=4&manpath=FreeBSD+7.3-stable">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ng_iface</span>(4)</span></a>
driver has been fixed. An infinite loop happened when a packet passes out via two
different <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=netgraph&sektion=3&manpath=FreeBSD+7.3-stable">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">netgraph</span>(3)</span></a>
interfaces sequentially due to tunneling.</p>

<p>A kernel option <code class="VARNAME">IPFW_DEFAULT_TO_ACCEPT</code> has been replaced
with a new loader tunable <code class="VARNAME">net.inet.ip.fw.default_to_accept</code>.
The value can be queried via a sysctl variable of the same name.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=tap&sektion=4&manpath=FreeBSD+7.3-stable"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">tap</span>(4)</span></a> software
network interface supports a new ioctl <code class="VARNAME">TAPGIFNAME</code>. This is
convenient shortcut ported from NetBSD to obtain network interface name using file
descriptor for character device.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=vlan&sektion=4&manpath=FreeBSD+7.3-stable">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">vlan</span>(4)</span></a> driver
is now enabled in the <tt class="FILENAME">GENERIC</tt> kernel.</p>
</div>

<div class="SECT3">
<hr />
<h4 class="SECT3"><a id="DISKS" name="DISKS">2.2.4 Disks and Storage</a></h4>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=aac&sektion=4&manpath=FreeBSD+7.3-stable"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">aac</span>(4)</span></a> driver has
been synchronized with the latest official vendor driver.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ahc&sektion=4&manpath=FreeBSD+7.3-stable"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">ahc</span>(4)</span></a> driver now
supports Adaptec 39320LPE adapters.</p>

<p>ATA command timeout in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ata&sektion=4&manpath=FreeBSD+7.3-stable"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">ata</span>(4)</span></a> driver has
been increased. This value can be set by using a kernel option <code
class="OPTION">ATA_REQUEST_TIMEOUT</code>.</p>

<p>A bug in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ata&sektion=4&manpath=FreeBSD+7.3-stable"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">ata</span>(4)</span></a> driver has
been fixed. It could generate an I/O request larger than controller's maximum I/O size
and caused a kernel panic.</p>

<p>An algorithm for <tt class="LITERAL">load</tt> balancing mode in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=gmirror&sektion=8&manpath=FreeBSD+7.3-stable">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">gmirror</span>(8)</span></a> GEOM
class has been changed and this mode is now set by default instead of <tt
class="LITERAL">split</tt>. The <tt class="LITERAL">load</tt> mode uses averaged number
of requests, running on each drive instead of measuring last request execution time for
each drive and choosing one with smallest time.</p>

<p>A bug in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=gpart&sektion=8&manpath=FreeBSD+7.3-stable">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">gpart</span>(8)</span></a> GEOM
class has been fixed. It could not handle a GPT header whose size is greater than 92
bytes which is written by OpenSolaris.</p>

<p>The default stripe size of <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=gstripe&sektion=8&manpath=FreeBSD+7.3-stable">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">gstripe</span>(8)</span></a> GEOM
class has been changed from 4KB to 64KB. This change will affect users preferring the <tt
class="COMMAND">create</tt> command over the <tt class="COMMAND">label</tt> command,
which will now need to explicitly specify the old stripe size (<code
class="OPTION">-s</code> <tt class="LITERAL">4096</tt>) in order to use their old <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=gstripe&sektion=8&manpath=FreeBSD+7.3-stable">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">gstripe</span>(8)</span></a>
volumes.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=hptrr&sektion=4&manpath=FreeBSD+7.3-stable">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">hptrr</span>(4)</span></a> driver
now supports a new loader tunable <code class="VARNAME">hw.hptrr.attach_generic</code> to
prevent the driver from being attached to some Marvell chips which have no HPT RAID
BIOS.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=mfi&sektion=4&manpath=FreeBSD+7.3-stable"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">mfi</span>(4)</span></a> driver now
supports LSI MegaRAID SAS 1078 and Dell PERC6.</p>
</div>

<div class="SECT3">
<hr />
<h4 class="SECT3"><a id="FS" name="FS">2.2.5 File Systems</a></h4>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ext2fs&sektion=5&manpath=FreeBSD+7.3-stable">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ext2fs</span>(5)</span></a> file
system has been improved. A bug when the inode size is other than 128 has been fixed.</p>

<p>FreeBSD Network File System now supports caching of negative pathname lookup in the
NFS client, and uses 3 seconds timeout (30 seconds in the prior releases) for caching
attributes of a directory in the client.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=pseudofs&sektion=9&manpath=FreeBSD+7.3-stable">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">pseudofs</span>(9)</span></a>
subsystem used in <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=procfs&sektion=5&manpath=FreeBSD+7.3-stable">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">procfs</span>(5)</span></a> and <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=linprocfs&sektion=5&manpath=FreeBSD+7.3-stable">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">linprocfs</span>(5)</span></a> are
now MPSAFE.</p>

<p><b class="APPLICATION">UFS_DIRHASH</b> (enabled by default) now supports removing the
cache data when the system memory is low (via <code class="VARNAME">vm_lowmem</code>
event handler). A bug that the system caused a panic when decreasing a sysctl variable
<code class="VARNAME">vfs.ufs.dirhash_maxmem</code> below the current amount of memory
used by <b class="APPLICATION">UFS_DIRHASH</b>, has been fixed.</p>

<p>A new sysctl variable for the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=VFS&sektion=9&manpath=FreeBSD+7.3-stable"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">VFS</span>(9)</span></a> subsystem
<code class="VARNAME">vfs.flushbufqtarget</code> has been added. This can fix issues in
<tt class="LITERAL">bufdaemon</tt>, a kernel process responsible for flushing dirty
buffers, which can cause the process to deadlock in a certain workload. The value of the
variable determines the number of buffers will be flushed before allocating a new buffer.
The default value of the variable on 7.3-RELEASE is <tt class="LITERAL">-1</tt>
(disabled). The FreeBSD 8.0-RELEASE uses <tt class="LITERAL">100</tt> by default.</p>

<p>ZFS has been updated from version 6 to version 13. This update includes numerous new
ZFS features, such as permitting non-<tt class="USERNAME">root</tt> users to perform some
administrative functions, supporting additional disks for caching or the ZFS Intent Log,
and partial <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=chflags&sektion=2&manpath=FreeBSD+7.3-stable">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">chflags</span>(2)</span></a>
support. It also includes some FreeBSD-specific additions, such as booting from ZFS file
systems, removal of ARC size limitations, ARC back pressure (which allows ZFS to work
without tunables on amd64), and many bugfixes.</p>
</div>
</div>

<div class="SECT2">
<hr />
<h3 class="SECT2"><a id="USERLAND" name="USERLAND">2.3 Userland Changes</a></h3>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=acpidump&sektion=8&manpath=FreeBSD+7.3-stable">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">acpidump</span>(8)</span></a>
utility now supports parsing SRAT (System Resource Affinity Table used to describe
affinity relationships between CPUs and memory.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=apropos&sektion=1&manpath=FreeBSD+7.3-stable">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">apropos</span>(1)</span></a>
command no longer sets the necessary directories to <code class="VARNAME">PATH</code>
variable. This means if the caller does not have <tt class="FILENAME">/bin</tt> and <tt
class="FILENAME">/usr/bin</tt> in <code class="VARNAME">PATH</code>, then it does not
work.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=bluetooth&sektion=3&manpath=FreeBSD+7.3-stable">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">bluetooth</span>(3)</span></a>
library now supports Bluetooth HCI API.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=btpand&sektion=8&manpath=FreeBSD+7.3-stable">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">btpand</span>(8)</span></a> daemon
now supports Bluetooth device node names in a <code class="OPTION">-d</code> option.</p>

<p>A bug in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=chflags&sektion=1&manpath=FreeBSD+7.3-stable">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">chflags</span>(1)</span></a> <code
class="OPTION">-h</code> option has been fixed. It used link target's flags as the
original one.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=cp&sektion=1&manpath=FreeBSD+7.3-stable"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">cp</span>(1)</span></a> command now
preserves file flags on symbolic links when options <code class="OPTION">-Rp</code> are
specified. It reported an error &#8220;function not implemented&#8221;.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=cpucontrol&sektion=8&manpath=FreeBSD+7.3-stable">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">cpucontrol</span>(8)</span></a>
command now allows user to perform atomic bitwise AND and OR operations on MSR registers.
Two new operations (<tt class="LITERAL">&#38;=</tt> and <tt class="LITERAL">|=</tt>) have
been added. The first one applies bitwise AND operation between the current contents of
the MSR register and the mask, and the second performs bitwise OR. The argument can be
optionally prefixed with <tt class="LITERAL">~</tt> inversion operator. The following is
an example to clear the second bit of TSC MSR:</p>

<pre class="SCREEN">
<samp class="PROMPT">#</samp> cpucontrol -m 0x10&#38;=~0x02
</pre>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=cpuset&sektion=1&manpath=FreeBSD+7.3-stable">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">cpuset</span>(1)</span></a>
command now supports interrupt binding by a new option <code class="OPTION">-x <tt
class="REPLACEABLE"><i>irq</i></tt></code>.</p>

<p>The default <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=crontab&sektion=5&manpath=FreeBSD+7.3-stable">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">crontab</span>(5)</span></a> file
no longer define a variable <code class="VARNAME">HOME</code>.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=df&sektion=1&manpath=FreeBSD+7.3-stable"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">df</span>(1)</span></a> command now
uses human-readable output for inode counts when an <code class="OPTION">-H</code> or
<code class="OPTION">-h</code> is specified.</p>

<p>A bug in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=dhclient&sektion=8&manpath=FreeBSD+7.3-stable">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">dhclient</span>(8)</span></a>
utility when appending a NUL-terminated text provided by a DHCP server, has been
fixed.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=dhclient&sektion=8&manpath=FreeBSD+7.3-stable">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">dhclient</span>(8)</span></a>
utility now uses <tt class="LITERAL">68</tt> (bootpc) as the source port for unicast <tt
class="LITERAL">DHCPREQUEST</tt> packets instead of allowing the protocol stack to pick a
random source port. This fixes the behavior where <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=dhclient&sektion=8&manpath=FreeBSD+7.3-stable">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">dhclient</span>(8)</span></a>
would never transition from <tt class="LITERAL">RENEWING</tt> to <tt
class="LITERAL">BOUND</tt> without going through <tt class="LITERAL">REBINDING</tt> in
some networks which has a tight policy on DHCP spoofing.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=fdisk&sektion=8&manpath=FreeBSD+7.3-stable">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">fdisk</span>(8)</span></a> utility
now supports size qualifiers (K, M, and G) and <tt class="LITERAL">*</tt> for automatic
calculation in the <tt class="COMMAND">p</tt> command.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=fetch&sektion=1&manpath=FreeBSD+7.3-stable">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">fetch</span>(1)</span></a> command
now supports HTTP digest authentication.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=fetch&sektion=1&manpath=FreeBSD+7.3-stable">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">fetch</span>(1)</span></a> command
now supports <code class="VARNAME">NO_PROXY</code> and <code
class="VARNAME">no_proxy</code> environment variables to disable use of HTTP proxy. For
more details, see <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=fetch&sektion=3&manpath=FreeBSD+7.3-stable">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">fetch</span>(3)</span></a> manual
page.</p>

<p>A bug in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=fetch&sektion=1&manpath=FreeBSD+7.3-stable">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">fetch</span>(1)</span></a> command
that <code class="VARNAME">FTP_TIMEOUT</code> and <code
class="VARNAME">HTTP_TIMEOUT</code> environment variables were ignored, has been
fixed.</p>

<p>A bug in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=fetch&sektion=1&manpath=FreeBSD+7.3-stable">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">fetch</span>(1)</span></a> command
that default parameters such as connection timeout were not set for HTTPS protocol, has
been fixed. It now uses the same parameters as HTTP.</p>

<p>A bug in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=find&sektion=1&manpath=FreeBSD+7.3-stable">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">find</span>(1)</span></a> command
has been fixed. It ignored an <code class="OPTION">-L</code> option when <code
class="OPTION">-delete</code> is specified. The following command can be safely used to
remove broken links:</p>

<pre class="SCREEN">
find -L . -type l -print0 | xargs rm -0
</pre>

<p>A bug in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=find&sektion=1&manpath=FreeBSD+7.3-stable">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">find</span>(1)</span></a> and <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=rm&sektion=1&manpath=FreeBSD+7.3-stable"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">rm</span>(1)</span></a> command has
been fixed. When a symbolic link has <tt class="LITERAL">uchg</tt> or <tt
class="LITERAL">uappend</tt> flag, the commands attempted to clear the target file, not
the symbolic link itself.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=gzip&sektion=1&manpath=FreeBSD+7.3-stable">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">gzip</span>(1)</span></a> command
now supports uncompressing files compressed by pack(1), which is found in some commercial
Unix systems.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ktrace&sektion=1&manpath=FreeBSD+7.3-stable">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ktrace</span>(1)</span></a>
utility now supports a new <tt class="LITERAL">KTRACE</tt> record for <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sysctl&sektion=3&manpath=FreeBSD+7.3-stable">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">sysctl</span>(3)</span></a>
invocations.</p>

<p>FreeBSD <b class="APPLICATION">libc</b> library now includes <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=fdopendir&sektion=3&manpath=FreeBSD+7.3-stable">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">fdopendir</span>(3)</span></a>
function.</p>

<p>FreeBSD <b class="APPLICATION">libc</b> library now includes <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=feature_present&sektion=3&manpath=FreeBSD+7.3-stable">
<span class="CITEREFENTRY"><span
class="REFENTRYTITLE">feature_present</span>(3)</span></a> function which checks to see
if a named kernel feature is present by checking the <code
class="VARNAME">kern.features</code> sysctl MIB.</p>

<p>FreeBSD <b class="APPLICATION">libc</b> library now includes <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=getpagesize&sektion=3&manpath=FreeBSD+7.3-stable">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">getpagesize</span>(3)</span></a>
function that returns either the number of page sizes supported by the system or a
specified subset of the supported page sizes.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=libradius&sektion=3&manpath=FreeBSD+7.3-stable">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">libradius</span>(3)</span></a> now
supports simple embedded RADIUS server.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=lp&sektion=1&manpath=FreeBSD+7.3-stable"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">lp</span>(1)</span></a> command now
supports <code class="OPTION">-m</code> option to send an email after the files have been
printed, and <code class="OPTION">-t <tt class="REPLACEABLE"><i>title</i></tt></code>
option to write <tt class="REPLACEABLE"><i>title</i></tt> on the banner page of the
output. These are required by POSIX standard.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=lpq&sektion=1&manpath=FreeBSD+7.3-stable"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">lpq</span>(1)</span></a> command now
correctly translates remote host names which contain non-standard end-of-line
characters.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=man&sektion=1&manpath=FreeBSD+7.3-stable"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">man</span>(1)</span></a> command now
supports manual pages in UTF-8.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=mergemaster&sektion=8&manpath=FreeBSD+7.3-stable">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">mergemaster</span>(8)</span></a>
utility now uses an <code class="OPTION">-L</code> option when it invokes <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=mtree&sektion=8&manpath=FreeBSD+7.3-stable">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">mtree</span>(8)</span></a> command
to follow symbolic links.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=mergemaster&sektion=8&manpath=FreeBSD+7.3-stable">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">mergemaster</span>(8)</span></a>
utility now supports <code class="VARNAME">DELETE_STALE_RC_FILES</code> variable in <tt
class="FILENAME">mergemaster.rc</tt> file to delete stale rc.d scripts automatically.</p>

<p>A userland utility <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=mfiutil&sektion=8&manpath=FreeBSD+7.3-stable">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">mfiutil</span>(8)</span></a> for
the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=mfi&sektion=4&manpath=FreeBSD+7.3-stable"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">mfi</span>(4)</span></a> devices has
been added. This includes basic features to monitor controller, array, and drive status,
change basic attributes, create/delete arrays and spares, and flush the controller
firmware. Note that this is a small utility, not a replacement of MegaCLI in the Ports
Collection which is supported officially and provides more functionality.</p>

<p>A userland utility <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=mptutil&sektion=8&manpath=FreeBSD+7.3-stable">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">mptutil</span>(8)</span></a> for
the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=mpt&sektion=4&manpath=FreeBSD+7.3-stable"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">mpt</span>(4)</span></a> devices has
been added. This includes basic features to monitor controller, array, and drive status,
change basic attributes, and create/delete arrays and spares.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=newfs_msdos&sektion=8&manpath=FreeBSD+7.3-stable">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">newfs_msdos</span>(8)</span></a>
command now supports media which have no CHS parameter.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ntpd&sektion=8&manpath=FreeBSD+7.3-stable">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ntpd</span>(8)</span></a> daemon
no longer tries to bind an IPv6 anycast address.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=pkill&sektion=1&manpath=FreeBSD+7.3-stable">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">pkill</span>(1)</span></a> command
now ignores itself and the ancestors when finding processes. An <code
class="OPTION">-a</code> option has been added for backward compatible behavior.</p>

<p>A race condition in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ppp&sektion=8&manpath=FreeBSD+7.3-stable"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">ppp</span>(8)</span></a> daemon has
been fixed.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ps&sektion=1&manpath=FreeBSD+7.3-stable"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">ps</span>(1)</span></a> command now
supports a new flag <code class="OPTION">-p</code>. This displays descendant info with
the output similar to Linux's <code class="OPTION">-H</code> (or <code
class="OPTION">-f</code>).</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=pwait&sektion=1&manpath=FreeBSD+7.3-stable">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">pwait</span>(1)</span></a>
command, which waits for any process to terminate has been added.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=pwd_mkdb&sektion=8&manpath=FreeBSD+7.3-stable">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">pwd_mkdb</span>(8)</span></a> now
verifies login name length is shorter than <code class="VARNAME">MAXLOGNAME</code> when a
<code class="OPTION">-C</code> option is specified. Note that entries with oversized
login names are still allowed in the passwd database, and <code
class="FUNCTION">getpwent*()</code> and <code class="FUNCTION">getpwuid*()</code>
functions return them correctly. The <code class="FUNCTION">getpwnam*()</code> truncates
them to <code class="VARNAME">MAXLOGNAME</code> - 1 when reading the database. The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=su&sektion=1&manpath=FreeBSD+7.3-stable"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">su</span>(1)</span></a> utility fails
for the long names.</p>

<p>The FreeBSD runtime linker, <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=rtld&sektion=1&manpath=FreeBSD+7.3-stable">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">rtld</span>(1)</span></a> has been
improved. The changes include:</p>

<ul>
<li>
<p>The dynamic string token substitution in the <tt class="LITERAL">rpath</tt> and <tt
class="LITERAL">soname</tt> has been implemented. This can be enabled by setting <code
class="OPTION">-z <tt class="REPLACEABLE"><i>origin</i></tt></code> option of <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ld&sektion=1&manpath=FreeBSD+7.3-stable"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">ld</span>(1)</span></a>. Currently, it
recognizes <code class="VARNAME">$OSNAME</code>, <code class="VARNAME">$PLATFORM</code>,
<code class="VARNAME">$OSREL</code>, and <code class="VARNAME">$ORIGIN</code> tokens.
This translation is unconditionally disabled for setuid/setgid processes.</p>
</li>

<li>
<p>PIE (Position Independent Executables) support has been improved. The runtime linker
now calculates relocation base for the main object, and applies the relocation adjustment
for all virtual addresses encoded into the ELF structures of it in order to make it
possible to load PIE binaries at a non-zero base address.</p>
</li>

<li>
<p>The way the mapping of the ELF objects has been changed to make wiring of the address
space possible. It now maps <tt class="LITERAL">PROT_NONE</tt> anonymous memory over the
whole range first, and then mapping the segments of the object over it. It allocates <tt
class="LITERAL">.bss</tt> by changing the protection of the range instead of remapping,
and unnecessary clearing of the text segment when its end is not page-aligned has been
eliminated.</p>
</li>

<li>
<p>A new environment variable <code class="VARNAME">LD_ELF_HINTS_PATH</code> for
overriding the rtld hints file has been supported. This feature gives a convenient way of
using a custom set of shared library that is not located in the default location and
switch back. This environment variable is automatically unset if the process is tainted
with setuid/setgid.</p>
</li>
</ul>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=strptime&sektion=3&manpath=FreeBSD+7.3-stable">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">strptime</span>(3)</span></a>
function now supports <tt class="LITERAL">%z</tt> format specifier.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sysinstall&sektion=8&manpath=FreeBSD+7.3-stable">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">sysinstall</span>(8)</span></a>
utility now supports a comma-separated list of network interfaces in <code
class="VARNAME">netDev</code> option in <tt class="FILENAME">install.cfg</tt>.</p>

<p>[ia64] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sysinstall&sektion=8&manpath=FreeBSD+7.3-stable">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">sysinstall</span>(8)</span></a>
utility now uses 400MB for the EFI partition instead of 100MB in the previous
releases.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=tail&sektion=1&manpath=FreeBSD+7.3-stable">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">tail</span>(1)</span></a> <code
class="OPTION">-F</code> flag now persists in trying to open files rather than giving up
when it encounters an error. <tt class="LITERAL">ENOENT</tt> errors are not reported.
This behavior is consistent with the GNU version.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=tftp&sektion=1&manpath=FreeBSD+7.3-stable">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">tftp</span>(1)</span></a> command
now returns a correct exit status in the case of successful file transfer.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=traceroute&sektion=8&manpath=FreeBSD+7.3-stable">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">traceroute</span>(8)</span></a>
program now uses in-kernel source address selection even in a <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=jail&sektion=8&manpath=FreeBSD+7.3-stable">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">jail</span>(8)</span></a>
environment.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=traceroute&sektion=8&manpath=FreeBSD+7.3-stable">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">traceroute</span>(8)</span></a>
and <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=traceroute6&sektion=8&manpath=FreeBSD+7.3-stable">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">traceroute6</span>(8)</span></a>
now support an <code class="OPTION">-a</code> flag to display AS number corresponding to
the lookup IP address on each hop. It will query the number to WHOIS server specified in
<code class="OPTION">-A</code> option. If no <code class="OPTION">-A</code> is specified,
<tt class="HOSTID">whois.radb.net</tt> will be used as the default value.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=tzsetup&sektion=8&manpath=FreeBSD+7.3-stable">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">tzsetup</span>(8)</span></a>
command now supports an <code class="OPTION">-s</code> option to skip the initial
question about adjusting the clock if not set to UTC.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=whois&sektion=1&manpath=FreeBSD+7.3-stable">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">whois</span>(1)</span></a> utility
has been updated. A <code class="OPTION">-d</code> option has been removed because <tt
class="HOSTID">whois.nic.mil</tt> no longer exists, and it supports searching for IPv6
addresses just like it can do for IPv4 addresses without having to explicitly specify
that the ARIN server should be used to get the initial information.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=yp&sektion=8&manpath=FreeBSD+7.3-stable"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">yp</span>(8)</span></a> utilities now
support <tt class="FILENAME">shadow.byname</tt> and <tt
class="FILENAME">shadow.byuid</tt> maps. These requires privileged port access.</p>

<div class="SECT3">
<hr />
<h4 class="SECT3"><a id="RC-SCRIPTS" name="RC-SCRIPTS">2.3.1 <tt
class="FILENAME">/etc/rc.d</tt> Scripts</a></h4>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=service&sektion=8&manpath=FreeBSD+7.3-stable">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">service</span>(8)</span></a>
command as an easy interface for the rc.d scripts has been added.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=rc.conf&sektion=5&manpath=FreeBSD+7.3-stable">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">rc.conf</span>(5)</span></a> file
now supports <code class="VARNAME">create_args_<tt
class="REPLACEABLE"><i>IF</i></tt></code> for interfaces created via <code
class="VARNAME">cloned_interfaces</code></p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=rc.conf&sektion=5&manpath=FreeBSD+7.3-stable">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">rc.conf</span>(5)</span></a> file
now supports <code class="VARNAME">vlans_<tt class="REPLACEABLE"><i>IF</i></tt></code>
for creating <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=vlan&sektion=4&manpath=FreeBSD+7.3-stable">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">vlan</span>(4)</span></a>
interfaces. If a vlan interface is a number, then that number is treated as the vlan tag
for the interface and the interface will be named &#8220;<tt
class="REPLACEABLE"><i>IF</i></tt>.<tt class="REPLACEABLE"><i>N</i></tt>&#8221;.
Otherwise, the vlan tag must be provided via a <code class="OPTION">vlan</code> parameter
in a <code class="VARNAME">create_args_<tt class="REPLACEABLE"><i>IF</i></tt></code>
variable.</p>

<p>The <tt class="FILENAME">rc.d/fsck</tt> script now supports options for <code
class="VARNAME">fsck_y_enable</code> via <code class="VARNAME">fsck_y_flags</code>.</p>

<p>The <tt class="FILENAME">rc.d/named</tt> script now supports zone file check by <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=named-checkconf&sektion=8&manpath=FreeBSD+7.3-stable">
<span class="CITEREFENTRY"><span
class="REFENTRYTITLE">named-checkconf</span>(8)</span></a> before the startup and the
following options:</p>

<ul>
<li>
<p><code class="VARNAME">named_wait</code> has the script loop until a specified hostname
in <code class="VARNAME">named_wait_host</code> (<tt class="HOSTID">localhost</tt> by
default) can be successfully looked up. This is disabled by default.</p>
</li>

<li>
<p><code class="VARNAME">named_auto_forward</code> creates a forwarder configuration file
based on the contents of <tt class="FILENAME">/etc/resolv.conf</tt>. This allows you to
utilize a local resolver for better performance, less network traffic, custom zones, etc.
while still relying on the benefits of your local network resolver. This is disabled by
default.</p>
</li>
</ul>

<p>The <tt class="FILENAME">rc.d/savecore</tt> script now supports invoking <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=crashinfo&sektion=8&manpath=FreeBSD+7.3-stable">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">crashinfo</span>(8)</span></a>
automatically during boot. A new variable <code class="VARNAME">crashinfo_enable</code>
has been added to enable it.</p>

<p>The <tt class="FILENAME">rc.d/static_arp</tt> script has been added. This allows the
administrator to statically bind MAC to IPv4 address at boot time. An example is as
follows:</p>

<pre class="PROGRAMLISTING">
static_arp_pairs="gw"
static_arp_gw="192.168.1.1 00:01:02:03:04:05"
</pre>
</div>
</div>

<div class="SECT2">
<hr />
<h3 class="SECT2"><a id="CONTRIB" name="CONTRIB">2.4 Contributed Software</a></h3>

<p><b class="APPLICATION">ISC BIND</b> has been updated to version 9.4-ESV.</p>

<p><b class="APPLICATION">sendmail</b> has been updated from version 8.14.3 to version
8.14.4.</p>

<p>The timezone database has been updated to the <b class="APPLICATION">tzdata2010b</b>
release.</p>

<p>The timezone libraries (stdtime part of <b class="APPLICATION">libc</b>) and related
binaries (<a
href="http://www.FreeBSD.org/cgi/man.cgi?query=zic&sektion=8&manpath=FreeBSD+7.3-stable"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">zic</span>(8)</span></a> and <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=zdump&sektion=8&manpath=FreeBSD+7.3-stable">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">zdump</span>(8)</span></a>) have
been updated to the <b class="APPLICATION">tzcode2009k</b> release. Note that <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=tzsetup&sektion=8&manpath=FreeBSD+7.3-stable">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">tzsetup</span>(8)</span></a> needs
to be run after the installation.</p>

<p><b class="APPLICATION">unifdef</b> has been updated to version 1.188.</p>
</div>

<div class="SECT2">
<hr />
<h3 class="SECT2"><a id="PORTS" name="PORTS">2.5 Ports/Packages Collection
Infrastructure</a></h3>

<p>A bug in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=pkg_info&sektion=1&manpath=FreeBSD+7.3-stable">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">pkg_info</span>(1)</span></a>
command which caused a segmentation fault when an invalid long option is specified, has
been fixed.</p>
</div>

<div class="SECT2">
<hr />
<h3 class="SECT2"><a id="RELENG" name="RELENG">2.6 Release Engineering and
Integration</a></h3>

<p>FreeBSD release ISO images now have &#8220;FreeBSD-&#8221; at the beginning of the
filenames.</p>

<p>The supported version of the <b class="APPLICATION">GNOME</b> desktop environment (<a
href="http://www.FreeBSD.org/cgi/url.cgi?ports/x11/gnome2/pkg-descr"><tt
class="FILENAME">x11/gnome2</tt></a>) has been updated to 2.28.2.</p>

<p>The supported version of the <b class="APPLICATION">KDE</b> desktop environment (<a
href="http://www.FreeBSD.org/cgi/url.cgi?ports/x11/kde4/pkg-descr"><tt
class="FILENAME">x11/kde4</tt></a>) has been updated to 4.3.5.</p>
</div>
</div>

<div class="SECT1">
<hr />
<h2 class="SECT1"><a id="UPGRADE" name="UPGRADE">3 Upgrading from previous releases of
FreeBSD</a></h2>

<p>[amd64, i386] Beginning with FreeBSD 6.2-RELEASE, binary upgrades between RELEASE
versions (and snapshots of the various security branches) are supported using the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=freebsd-update&sektion=8&manpath=FreeBSD+7.3-stable">
<span class="CITEREFENTRY"><span
class="REFENTRYTITLE">freebsd-update</span>(8)</span></a> utility. The binary upgrade
procedure will update unmodified userland utilities, as well as unmodified GENERIC or SMP
kernels distributed as a part of an official FreeBSD release. The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=freebsd-update&sektion=8&manpath=FreeBSD+7.3-stable">
<span class="CITEREFENTRY"><span
class="REFENTRYTITLE">freebsd-update</span>(8)</span></a> utility requires that the host
being upgraded has Internet connectivity.</p>

<p>An older form of binary upgrade is supported through the <tt
class="COMMAND">Upgrade</tt> option from the main <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sysinstall&sektion=8&manpath=FreeBSD+7.3-stable">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">sysinstall</span>(8)</span></a>
menu on CDROM distribution media. This type of binary upgrade may be useful on non-i386,
non-amd64 machines or on systems with no Internet connectivity.</p>

<p>Source-based upgrades (those based on recompiling the FreeBSD base system from source
code) from previous versions are supported, according to the instructions in <tt
class="FILENAME">/usr/src/UPDATING</tt>.</p>

<div class="IMPORTANT">
<blockquote class="IMPORTANT">
<p><b>Important:</b> Upgrading FreeBSD should, of course, only be attempted after backing
up <span class="emphasis"><i class="EMPHASIS">all</i></span> data and configuration
files.</p>
</blockquote>
</div>
</div>
</div>

<hr />
<p align="center"><small>This file, and other release-related documents, can be
downloaded from <a href="ftp://ftp.FreeBSD.org/">ftp://ftp.FreeBSD.org/</a>.</small></p>

<p align="center"><small>For questions about FreeBSD, read the <a
href="http://www.FreeBSD.org/docs.html">documentation</a> before contacting &#60;<a
href="mailto:questions@FreeBSD.org">questions@FreeBSD.org</a>&#62;.</small></p>

<p align="center"><small>All users of FreeBSD 7.3-STABLE should subscribe to the &#60;<a
href="mailto:stable@FreeBSD.org">stable@FreeBSD.org</a>&#62; mailing list.</small></p>

<p align="center"><small>For questions about this documentation, e-mail &#60;<a
href="mailto:doc@FreeBSD.org">doc@FreeBSD.org</a>&#62;.</small></p>
++++


